<template>
  <a-modal
    :visible="visible"
    :confirm-loading="loading"
    @cancel="handleCancel"
    @ok="handleOK"
    title="Create scout message"
    ok-text="OK"
  >
    <a-form :form="form" layout="vertical">
      <a-form-item
        label="Site (*):"
        has-feedback
      >
        <a-select
          v-if="sites"
          v-decorator="[
            'siteId',
            {
              rules: [{
                required: true,
                message: 'Choose alias site to send scout message'
              }]
            }
          ]"
          style="width: 100%"
          placeholder="Choose alias site"
        >
          <a-icon slot="suffixIcon" type="caret-down" class="srp-darkest" />
          <a-select-option
            v-for="site in sites"
            :key="site.pk"
          >
            {{ site.pk }}
          </a-select-option>
        </a-select>
      </a-form-item>
      <a-form-item label="Content">
        <a-textarea
          :auto-size="{ minRows: 3, maxRows: 6 }"
          v-decorator="[
            'content',
            {
              rules: [{
                required: true,
                message: 'Message content is required'
              }]
            }
          ]"
          style="width: 100%"
          placeholder="Message content"
        />
      </a-form-item>
    </a-form>
  </a-modal>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  name: 'CreateScoutMessageModal',
  props: {
    submit: {
      type: Function,
      default: () => {}
    }
  },
  data () {
    return {
      visible: false,
      loading: false,
      seekerId: null
    }
  },
  computed: {
    ...mapGetters('sites', ['sites'])
  },
  beforeCreate () {
    this.form = this.$form.createForm(this)
  },
  methods: {
    showModal (id) {
      this.visible = true
      this.seekerId = id
    },
    reset () {
      this.form.resetFields()
      this.visible = false
      this.seekerId = null
    },
    handleCancel () {
      this.visible = false
      this.loading = false
      this.reset()
    },
    handleOK (e) {
      e.preventDefault()
      this.form.validateFields(async (err, values) => {
        if (err) {
          return
        }
        const { siteId, content } = values
        const selectedSite = this.sites.filter(site => site.pk === siteId)[0]
        const input = {
          seekerId: this.seekerId,
          recruiterId: selectedSite.recruiterId,
          siteId,
          displayTitle: `スカウト - ${selectedSite.info && selectedSite.info.facilityName}`,
          displayLink: `http://${siteId}.stag-srp.sk-global.io`,
          content
        }
        this.loading = true
        await this.submit(input)
        this.loading = false
        this.reset()
      })
    }
  }
}
</script>
